<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package designer_dresses
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function designer_dresses_body_classes( $classes ) {
  global $designer_dresses_post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

    if ( is_multi_author() ) {
        $classes[] = 'group-blog ';
    }

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( designer_dresses_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
        $classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

    return $classes;
}
add_filter( 'body_class', 'designer_dresses_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function designer_dresses_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'designer_dresses_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function designer_dresses_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'designer_dresses_excerpt_more' );


if( ! function_exists( 'designer_dresses_footer_credit' ) ):
/**
 * Footer Credits
*/
function designer_dresses_footer_credit() {

    // Check if footer copyright is enabled
    $designer_dresses_show_footer_copyright = get_theme_mod( 'designer_dresses_footer_setting', true );

    if ( ! $designer_dresses_show_footer_copyright ) {
        return; 
    }

    $designer_dresses_copyright_text = get_theme_mod('designer_dresses_footer_copyright_text');

    $designer_dresses_text = '<div class="site-info"><div class="container"><span class="copyright">';
    if ($designer_dresses_copyright_text) {
        $designer_dresses_text .= wp_kses_post($designer_dresses_copyright_text); 
    } else {
        $designer_dresses_text .= esc_html__('&copy; ', 'designer-dresses') . date_i18n(esc_html__('Y', 'designer-dresses')); 
        $designer_dresses_text .= ' <a href="' . esc_url(home_url('/')) . '">' . esc_html(get_bloginfo('name')) . '</a>' . esc_html__('. All Rights Reserved.', 'designer-dresses');
    }
    $designer_dresses_text .= '</span>';
    $designer_dresses_text .= '<span class="by"> <a href="' . esc_url('https://www.themeignite.com/products/free-dresses-wordpress-theme') . '" rel="nofollow" target="_blank">' . DESIGNER_DRESSES_THEME_NAME . '</a>' . esc_html__(' By ', 'designer-dresses') . '<a href="' . esc_url('https://themeignite.com/') . '" rel="nofollow" target="_blank">' . esc_html__('Themeignite', 'designer-dresses') . '</a>.';
    /* translators: %s: link to WordPress.org */
    $designer_dresses_text .= sprintf(esc_html__(' Powered By %s', 'designer-dresses'), '<a href="' . esc_url(__('https://wordpress.org/', 'designer-dresses')) . '" target="_blank">WordPress</a>.');
    if (function_exists('the_privacy_policy_link')) {
        $designer_dresses_text .= get_the_privacy_policy_link();
    }
    $designer_dresses_text .= '</span></div></div>';
    echo apply_filters('designer_dresses_footer_text', $designer_dresses_text);
}
add_action('designer_dresses_footer', 'designer_dresses_footer_credit');
endif;


/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'designer_dresses_woocommerce_activated' ) ) {
  function designer_dresses_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'designer_dresses_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function designer_dresses_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $designer_dresses_commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $designer_dresses_aria_req = ( $req ? " aria-required='true'" : '' );
    $designer_dresses_required = ( $req ? " required" : '' );
    $designer_dresses_author   = ( $req ? __( 'Name*', 'designer-dresses' ) : __( 'Name', 'designer-dresses' ) );
    $designer_dresses_email    = ( $req ? __( 'Email*', 'designer-dresses' ) : __( 'Email', 'designer-dresses' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'designer-dresses' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $designer_dresses_author ) . '" type="text" value="' . esc_attr( $designer_dresses_commenter['comment_author'] ) . '" size="30"' . $designer_dresses_aria_req . $designer_dresses_required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'designer-dresses' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $designer_dresses_email ) . '" type="text" value="' . esc_attr(  $designer_dresses_commenter['comment_author_email'] ) . '" size="30"' . $designer_dresses_aria_req . $designer_dresses_required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'designer-dresses' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'designer-dresses' ) . '" type="text" value="' . esc_attr( $designer_dresses_commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'designer_dresses_change_comment_form_default_fields' );

if( ! function_exists( 'designer_dresses_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function designer_dresses_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'designer-dresses' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'designer-dresses' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'designer_dresses_change_comment_form_defaults' );

if( ! function_exists( 'designer_dresses_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function designer_dresses_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
    /**
     * Triggered after the opening <body> tag.
    */
    do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'designer_dresses_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function designer_dresses_get_fallback_svg( $designer_dresses_post_thumbnail ) {
    if( ! $designer_dresses_post_thumbnail ){
        return;
    }
    
    $designer_dresses_image_size = designer_dresses_get_image_sizes( $designer_dresses_post_thumbnail );
     
    if( $designer_dresses_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $designer_dresses_image_size['width'] ); ?> <?php echo esc_attr( $designer_dresses_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $designer_dresses_image_size['width'] ); ?>" height="<?php echo esc_attr( $designer_dresses_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function designer_dresses_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
            'google-fonts-poppins',
        wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Arimo:ital,wght@0,400..700;1,400..700&family=Merienda:wght@300..900&family=Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&family=Roboto:ital,wght@0,100;0,300;0,400;0,500;0,700;0,900;1,100;1,300;1,400;1,500;1,700;1,900&family=Sail&display=swap' ),
        array(),
        '1.0'
    );

    wp_enqueue_style(
        'google-fonts-inter',
        wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Inter:ital,opsz,wght@0,14..32,100..900;1,14..32,100..900&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'designer_dresses_enqueue_google_fonts' );


if( ! function_exists( 'designer_dresses_site_branding' ) ) :
/**
 * Site Branding
*/
function designer_dresses_site_branding(){
    $designer_dresses_logo_site_title = get_theme_mod( 'header_site_title', 0 );
    $designer_dresses_tagline = get_theme_mod( 'header_tagline', false );
    $designer_dresses_logo_width = get_theme_mod('logo_width', 100); // Retrieve the logo width setting

    ?>
    <div class="site-branding" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '-1'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($designer_dresses_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('designer_dresses_site_title_size', '30')); ?>px;">
            <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
          </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($designer_dresses_tagline) :
            $designer_dresses_description = get_bloginfo('description', 'display');
            if ($designer_dresses_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $designer_dresses_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'designer_dresses_navigation' ) ) :
/**
 * Site Navigation
*/
function designer_dresses_navigation(){
    ?>
    <nav class="main-navigation" id="site-navigation"  role="navigation">
        <?php 
        wp_nav_menu( array( 
            'theme_location' => 'primary', 
            'menu_id' => 'primary-menu' 
        ) ); 
        ?>
    </nav>
    <?php
}
endif;

if( ! function_exists( 'designer_dresses_header' ) ) :
/**
 * Header Start
*/
function designer_dresses_header(){
        $designer_dresses_header_image = get_header_image();
        $designer_dresses_sticky_header = get_theme_mod('designer_dresses_sticky_header');
        $designer_dresses_location     = get_theme_mod( 'designer_dresses_header_location' );
        $designer_dresses_phone        = get_theme_mod( 'designer_dresses_header_phone' );
        $designer_dresses_email        = get_theme_mod( 'designer_dresses_header_email' );
        $designer_dresses_phone_text        = get_theme_mod( 'designer_dresses_phone_text' );
        $designer_dresses_header_btn_text     = get_theme_mod( 'designer_dresses_header_btn_text' );
        $designer_dresses_header_btn_url     = get_theme_mod( 'designer_dresses_header_btn_url' );
    ?>
    <div id="page-site-header">
        <header id="masthead" class="site-header" style="background-image: url('<?php echo esc_url( $designer_dresses_header_image ); ?>');" data-sticky="<?php echo $designer_dresses_sticky_header; ?>" role="banner">
            <div class="container">
                <div class="row logo-border">
                    <div class="col-xl-3 col-lg-12 col-md-12 align-self-center">
                        <?php designer_dresses_site_branding(); ?>
                    </div>
                    <div class="col-xl-9 col-lg-12 col-md-0 align-self-center">
                        <div class="row py-2 m-0 head-border">
                            <div class="col-lg-9 col-lg-9 col-md-12">
                                <div class="row contact-detail">
                                    <div class="col-xl-4 col-lg-4 col-md-4 col-sm-4 align-self-center">
                                      <?php if ( $designer_dresses_email ){?>
                                            <span><a href="mailto:<?php echo esc_attr($designer_dresses_email);?>"><i class="<?php echo esc_attr(get_theme_mod('designer_dresses_mail_icon','fas fa-envelope')); ?>"></i> <?php echo esc_html($designer_dresses_email);?></a></span>
                                        <?php } ?>  
                                    </div>
                                    <div class="col-xl-4 col-lg-5 col-md-4 col-sm-4 align-self-center">
                                        <?php if ( $designer_dresses_location ){?>
                                            <span>
                                                <i class="<?php echo esc_attr(get_theme_mod('designer_dresses_marker_icon','fas fa-clock')); ?>"></i>
                                                <?php echo esc_html( $designer_dresses_location );?>
                                            </span>
                                        <?php } ?>  
                                    </div>
                                    <div class="col-xl-4 col-lg-3 col-md-4 col-sm-4 align-self-center">
                                        <?php
                                            $designer_dresses_social_icon = get_theme_mod('designer_dresses_social_icon_setting', false);
                                            if ($designer_dresses_social_icon):
                                            ?>
                                                <div class="social-links">
                                                    <?php
                                                    $designer_dresses_social_link1 = get_theme_mod('designer_dresses_social_link_1');
                                                    $designer_dresses_social_link2 = get_theme_mod('designer_dresses_social_link_2');
                                                    $designer_dresses_social_link3 = get_theme_mod('designer_dresses_social_link_3');
                                                    $designer_dresses_social_link4 = get_theme_mod('designer_dresses_social_link_4');

                                                    if (!empty($designer_dresses_social_link1)) {
                                                        echo '<a class="social1" href="' . esc_url($designer_dresses_social_link1) . '" target="_blank"><i class="fab fa-facebook-f"></i></a>';
                                                    }
                                                    if (!empty($designer_dresses_social_link2)) {
                                                        echo '<a class="social2" href="' . esc_url($designer_dresses_social_link2) . '" target="_blank"><i class="fab fa-twitter"></i></a>';
                                                    }
                                                    if (!empty($designer_dresses_social_link3)) {
                                                        echo '<a class="social3" href="' . esc_url($designer_dresses_social_link3) . '" target="_blank"><i class="fab fa-instagram"></i></a>';
                                                    }
                                                    if (!empty($designer_dresses_social_link4)) {
                                                        echo '<a class="social4" href="' . esc_url($designer_dresses_social_link4) . '" target="_blank"><i class="fab fa-pinterest-p"></i></a>';
                                                    }
                                                    ?>
                                                </div>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                            <div class="col-xl-3 col-lg-3 col-md-12 col-sm-12 align-self-center text-lg-end">
                               <?php if ( $designer_dresses_header_btn_text ){?>
                                    <div class="menudiv-button">
                                        <a href="<?php echo esc_url($designer_dresses_header_btn_url);?>"> <?php echo esc_html($designer_dresses_header_btn_text);?></a>
                                    </div>
                                <?php } ?>   
                            </div>
                        </div>
                        <div class="row py-1 head-border">
                            <div class="col-xl-9 col-lg-9 align-self-center">
                              <?php designer_dresses_navigation(); ?>  
                            </div>
                            <div class="col-lg-3 col-lg-3 phone-no">
                                <?php if ( $designer_dresses_phone ){?>
                                    <div class="row">
                                        <div class="col-lg-2 col-4 text-md-end align-self-center">
                                           <i class="<?php echo esc_attr(get_theme_mod('designer_dresses_phone_icon','fas fa-mobile-alt')); ?>"></i> 
                                        </div>
                                        <div class="col-lg-10 col-8 text-md-start align-self-center cont-detail">
                                            <p class="mb-0"><?php echo esc_html( $designer_dresses_phone_text);?></p>
                                            <a href="tel:<?php echo esc_attr($designer_dresses_phone);?>">
                                            <?php echo esc_html( $designer_dresses_phone);?></span></a>
                                        </div>
                                    </div>
                                <?php } ?> 
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </header>
    </div>
    <?php
}
endif;
add_action( 'designer_dresses_header', 'designer_dresses_header', 20 );